stages:
- static-analysis
- composition-analysis
- build
- notify
build-docker:
  stage: build
  image: docker:20
  services:
    - docker:20-dind
  script:
    - docker login --username $CI_REGISTRY_USER --password $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - >
      docker build
      --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
      .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
  except:
    - tags
build-docker-tag:
  stage: build
  image: docker:20
  services:
    - docker:20-dind
  script:
    - docker login --username $CI_REGISTRY_USER --password $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - >
      docker build
      --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
      .
    - docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
  only:
    - tags
notify-humanitec:
  stage: notify
  image: alpine:3.16
  before_script:
    - apk update
    - apk add curl
  script:
    - > 
      curl
      --request POST "https://api.humanitec.io/orgs/plaintextnerds-ltd/artefact-versions"
      --header "Authorization: Bearer $HUMANITEC_TOKEN"
      --header "Content-Type: application/json"
      --data-raw '{
      "name": "'${CI_REGISTRY_IMAGE}'",
      "version": "'${CI_COMMIT_TAG}'",
      "type": "container",
      "commit": "'${CI_COMMIT_SHORT_SHA}'"
      }'
  only:
    - tags
lint:
  stage: static-analysis
  image:
    name: ckleemann/prospector:latest
    entrypoint:
    - ''
  before_script:
  - pip install --upgrade pip
  - pip install poetry
  - poetry install
  script:
  - poetry run prospector -P ./prospector-profile.yml ./src
  allow_failure: true
  except:
    - tags
semgrep:
  stage: static-analysis
  image: returntocorp/semgrep-agent:v1
  script: semgrep-agent
  variables:
    INPUT_CONFIG: p/security-audit p/secrets
  except:
    - tags


